routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers as Controladores;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth:: routes(['register' => false]);

Route::get('/home', [Controladores\HomeController::class, 'index'])->name('home');

Route::resource('users', Controladores\UserController::class)->middleware('auth');
Route::resource('providers', Controladores\ProviderController::class)->middleware('auth');
Route::resource('productos', Controladores\ProductoController::class)->middleware('auth');
Route::resource('clientes', Controladores\ClienteController::class)->middleware('auth');
Route::resource('especie-mascotas', Controladores\EspecieMascotaController::class)->middleware('auth');
Route::resource('mascotas', Controladores\MascotaController::class)->middleware('auth');
Route::resource('servicios', Controladores\ServicioController::class)->middleware('auth');
Route::resource('ventas', Controladores\VentaController::class)->except(['store'])->middleware('auth');
Route::get('consultas/atencion',[Controladores\ConsultaController::class,'atencion'])->middleware('auth')->name('consultas.atencion');
Route::get('consultas/programacion',[Controladores\ConsultaController::class,'programacion'])->middleware('auth')->name('consultas.programacion');
Route::resource('consultas', Controladores\ConsultaController::class)->middleware('auth');
Route::get('consultas/{consulta}/editDetail',[Controladores\ConsultaController::class,'editDetail'])->middleware('auth')->name('consultas.editDetail');
Route::patch('consultas/{consulta}',[Controladores\ConsultaController::class,'saveDetail'])->middleware('auth')->name('consultas.saveDetail');

app/Models/Producto.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

/**
 * Class Producto
 *
 * @property $id
 * @property $nombre
 * @property $marca
 * @property $unidad_medida
 * @property $descripcion
 * @property $fotos
 * @property $cantidad
 * @property $costo_unidad
 * @property $created_at
 * @property $updated_at
 *
 * @property DetalleVentaProducto[] $detalleVentaProductos
 * @package App
 * @mixin \Illuminate\Database\Eloquent\Builder
 */
class Producto extends Model
{
    
    static $rules = [
        'nombre' => 'required|string|min:3|max:100',
        'id_proveedor' => 'required|numeric|min:1',
        'unidad_medida' => 'required|string|max:100',
        'descripcion' => 'required|string|max:300',
        'fotos' => 'required',
        'fotos.*' => 'image',
        'cantidad' => 'required|numeric|min:0',
        'costo_unidad' => 'required|numeric|min:0.1',
    ];

    /**
     * Attributes that should be mass-assignable.
     *
     * @var array
     */
    protected $fillable = ['nombre','id_proveedor','unidad_medida','descripcion','fotos','cantidad','costo_unidad'];


    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function detalleVentaProductos()
    {
        return $this->hasMany('App\Models\DetalleVentaProducto', 'id_producto', 'id');
    }

    public function provider()
    {
        return $this->belongsTo('App\Models\Provider', 'id_proveedor', 'id');
    }
    

}

app/Http/Controllers/ProductoController.php
<?php

namespace App\Http\Controllers;

use App\Models\Producto;
use App\Models\Provider;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

/**
 * Class ProductoController
 * @package App\Http\Controllers
 */
class ProductoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $productos = Producto::with('provider:id,nombre')->get();

        return view('producto.index', compact('productos'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $producto = new Producto();
        $proveedores = Provider::select('id', 'nombre')->get();

        return view('producto.create', compact('producto','proveedores'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        request()->validate(Producto::$rules);

        $images = "";

        foreach ($request->file('fotos') as $file ) {
            $path = $file->store('public/productos');
            $image = str_replace('public/','storage/',$path);
            $images .= "$image,";
        }

        $newProduct = $request->except('fotos');
        $newProduct['fotos'] = substr($images,0,-1);

        Producto::create($newProduct);

        return redirect()->route('productos.index')
            ->with('success', 'Se creó el producto correctamente');
    }

    /**
     * Display the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $producto = Producto::with('provider:id,nombre')->find($id);

        return view('producto.show', compact('producto'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $producto = Producto::find($id);
        $proveedores = Provider::select('id', 'nombre')->get();

        return view('producto.edit', compact('producto','proveedores'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  Producto $producto
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Producto $producto)
    {
        $updrules = [
            'fotos' => 'nullable'
        ];

        request()->validate(array_replace(Producto::$rules,$updrules));
        $images = "";

        if($request->hasFile('fotos')){
            foreach ($request->file('fotos') as $file ) {
                $path = $file->store('public/productos');
                $image = str_replace('public/','storage/',$path);
                $images .= "$image,";
            }

            $newProduct = $request->except('fotos');
            $newProduct['fotos'] = substr($images,0,-1);
            $producto->update($newProduct);
        }
        else{
            $producto->update($request->all());
        }

        return redirect()->route('productos.index')
            ->with('success', 'Se actualizaron los datos correctamente');
    }

    /**
     * @param int $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Exception
     */
    public function destroy($id)
    {
        $producto = Producto::find($id)->delete();

        return redirect()->route('productos.index')
            ->with('success', 'El Producto se eliminó correctamente');
    }
}

resources/views/producto/create.blade.php
@extends('layouts.app')

@section('template_title')
    Registro de Producto
@endsection

@section('content')
    <section class="content container-fluid">
        <div class="row">
            <div class="col-md-12">

                @includeif('partials.errors')

                <div class="card card-default">
                    <div class="card-header">
                        <span class="card-title">Registro de Producto</span>
                    </div>
                    <div class="card-body">
                        <form method="POST" action="{{ route('productos.store') }}"  role="form" enctype="multipart/form-data">
                            @csrf

                            @include('producto.form')

                        </form>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

resources/views/producto/edit.blade.php
@extends('layouts.app')

@section('template_title')
    Modificar Producto
@endsection

@section('content')
    <section class="content container-fluid">
        <div class="row">
            <div class="col-md-12">

                @includeif('partials.errors')

                <div class="card card-default">
                    <div class="card-header">
                        <span class="card-title">Actualizar Producto</span>
                    </div>
                    <div class="card-body">
                        <form method="POST" action="{{ route('productos.update', $producto->id) }}"  role="form" enctype="multipart/form-data">
                            {{ method_field('PATCH') }}
                            @csrf

                            @include('producto.form')
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

resources/views/producto/form.blade.php
@section('estilos')
    <link rel="stylesheet" href="{{ asset('css/image-uploader.css') }}">
@endsection

<div class="box box-info padding-1">
    <div class="box-body">

        <div class="form-group">
            {{ Form::label('nombre') }}
            {{ Form::text('nombre', $producto->nombre, ['class' => 'form-control' . ($errors->has('nombre') ? ' is-invalid' : ''), 'placeholder' => 'Nombre']) }}
            {!! $errors->first('nombre', '<p class="invalid-feedback">:message</p>') !!}
        </div>
        <div class="form-group">
            {{ Form::label('id_proveedor', 'Proveedor') }}
            <select name="id_proveedor" id="id_proveedor" class="form-control {{ $errors->has('id_proveedor') ? ' is-invalid' : '' }}">
                <option value=""> - seleccione - </option>
                @foreach ($proveedores as $proveedor)
                    <option @if ($producto->id_proveedor !== null && $producto->id_proveedor === $proveedor->id) selected @endif value="{{ $proveedor->id }}">{{ $proveedor->nombre }}</option>
                @endforeach
            </select>
        </div>
        <div class="form-group">
            {{ Form::label('unidad_medida') }}
            {{ Form::select('unidad_medida', ['gramos' => 'gramos(g)', 'kilos' => 'kilos(kg)', 'unidad' => 'unidad (und)'], $producto->unidad_medida, ['class' => 'form-control' . ($errors->has('unidad_medida') ? ' is-invalid' : ''), 'placeholder' => '- seleccione -']) }}
            {!! $errors->first('unidad_medida', '<p class="invalid-feedback">:message</p>') !!}
        </div>
        <div class="form-group">
            {{ Form::label('descripcion', 'Descripción') }}
            {{ Form::textarea('descripcion', $producto->descripcion, ['class' => 'form-control' . ($errors->has('descripcion') ? ' is-invalid' : ''), 'placeholder' => 'Descripción']) }}
            {!! $errors->first('descripcion', '<p class="invalid-feedback">:message</p>') !!}
        </div>
        <div class="form-group row">
            <div class="col-6">
                {{ Form::label('cantidad') }}
                {{ Form::number('cantidad', $producto->cantidad, ['class' => 'form-control' . ($errors->has('cantidad') ? ' is-invalid' : ''), 'placeholder' => 'Cantidad', 'min'=>'0', 'step'=>'0.1']) }}
                {!! $errors->first('cantidad', '<p class="invalid-feedback">:message</p>') !!}
            </div>
            <div class="col-6">
                {{ Form::label('costo_unidad') }}
                {{ Form::number('costo_unidad', $producto->costo_unidad, ['class' => 'form-control' . ($errors->has('costo_unidad') ? ' is-invalid' : ''), 'placeholder' => 'Costo Unidad', 'min'=>'0.1', 'step'=>'0.1']) }}
                {!! $errors->first('costo_unidad', '<p class="invalid-feedback">:message</p>') !!}
            </div>
        </div>
        <div class="form-group">
            {{ Form::label('fotos') }}
            <div id="multifile" class="{{ $errors->has('fotos') ? ' is-invalid' : '' }}"></div>
            @if(Route::is('productos.edit'))
                <p class="text-muted"><small>Tenga en cuenta que las fotografías que suba durante la edición reemplazarán a las actuales, si no desea modificarlas puede dejar este campo en blanco</small></p>
            @endif
            {!! $errors->first('fotos', '<p class="invalid-feedback">:message</p>') !!}
        </div>
    </div>
    <div class="box-footer mt20">
        <button type="submit" class="btn btn-primary">GUARDAR</button>
    </div>
</div>

@section('scripts')
    <script src="{{ asset('js/image-uploader.js') }}"></script>
    <script>
        $(function(){
            $('#multifile').imageUploader({
                maxSize: 3145728,
                maxFiles: 3,
                imagesInputName:'fotos',
            });
        });
    </script>
@endsection

resources/views/producto/index.blade.php
@extends('layouts.app')

@section('estilos')
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/css/lightbox.min.css" integrity="sha512-ZKX+BvQihRJPA8CROKBhDNvoc2aDMOdAlcm7TUQY+35XYtrd3yh95QOOhsPDQY9QnKE0Wqag9y38OIgEvb88cA==" crossorigin="anonymous" referrerpolicy="no-referrer" />
<style>.lb-data .lb-number{display: none !important;}</style>
@endsection

@section('template_title')
    Producto
@endsection

@section('content')
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12">
                <div class="card">
                    <div class="card-header">
                        <div style="display: flex; justify-content: space-between; align-items: center;">

                            <span id="card_title">
                                {{ __('Producto') }}
                            </span>

                            <div class="float-right">
                                <a href="{{ route('productos.create') }}" class="btn btn-primary btn-sm float-right"  data-placement="left">
                                    {{ __('Agregar Producto') }}
                                </a>
                            </div>
                        </div>
                    </div>
                    @if ($message = Session::get('success'))
                        <div class="alert alert-success">
                            <p>{{ $message }}</p>
                        </div>
                    @endif

                    <div class="card-body">
                        <div class="table-responsive">
                            <table class="table table-striped table-hover">
                                <thead class="thead">
                                    <tr>
                                        <th>No</th>

										<th>Nombre</th>
										<th>Marca</th>
										<th>Unidad Medida</th>
										{{-- <th>Descripción</th> --}}
										<th>Fotos</th>
										<th>Cantidad</th>
										<th>Costo Unidad</th>

                                        <th></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach ($productos as $producto)
                                        <tr>
                                            <td>{{ $loop->index+1 }}</td>

											<td>{{ $producto->nombre }}</td>
											<td>{{ $producto->provider->nombre }}</td>
											<td>{{ $producto->unidad_medida }}</td>
											<td>
                                                @foreach(explode(',', $producto->fotos) as $urlfoto)
                                                    <a class="btn btn-sm btn-primary @if (!$loop->first) d-none @endif" href="{{ $urlfoto }}" data-lightbox="fotos{{ $loop->parent->index }}">Ver Fotos</a>
                                                @endforeach
                                            </td>
											<td>{{ $producto->cantidad }}</td>
											<td>{{ $producto->costo_unidad }}</td>

                                            <td>
                                                <form action="{{ route('productos.destroy',$producto->id) }}" method="POST">
                                                    <a class="btn btn-sm btn-primary " href="{{ route('productos.show',$producto->id) }}"><i class="fa fa-fw fa-eye"></i> Detalles</a>
                                                    <a class="btn btn-sm btn-success" href="{{ route('productos.edit',$producto->id) }}"><i class="fa fa-fw fa-edit"></i> Editar</a>
                                                    @csrf
                                                    @method('DELETE')
                                                    <button type="button" class="btn btn-danger btn-sm deler"><i class="fa fa-fw fa-trash"></i> Eliminar</button>
                                                </form>
                                            </td>
                                        </tr>
                                    @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('scripts')
<script src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/js/lightbox.min.js" integrity="sha512-k2GFCTbp9rQU412BStrcD/rlwv1PYec9SNrkbQlo6RZCf75l6KcC3UwDY8H5n5hl4v77IDtIPwOk9Dqjs/mMBQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
<script>
    $(function(){
        $(".deler").click(function(){
            if(confirm("¿Desea eliminar el producto?")){
                $(this).parent().submit();
            }
        });
    });
</script>
@endsection

resources/views/producto/show.blade.php
@extends('layouts.app')

@section('template_title')
    {{ $producto->name ?? 'Detalle de Producto' }}
@endsection

@section('content')
    <section class="content container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <div class="float-left">
                            <span class="card-title">Detalle de Producto</span>
                        </div>
                        <div class="float-right">
                            <a class="btn btn-sm btn-primary" href="{{ route('productos.index') }}"> Volver</a>
                        </div>
                    </div>

                    <div class="card-body">

                        <div class="form-group">
                            <strong>Nombre:</strong>
                            {{ $producto->nombre }}
                        </div>
                        <div class="form-group">
                            <strong>Marca:</strong>
                            {{ $producto->provider->nombre }}
                        </div>
                        <div class="form-group">
                            <strong>Unidad Medida:</strong>
                            {{ $producto->unidad_medida }}
                        </div>
                        <div class="form-group">
                            <strong>Descripción:</strong>
                            {{ $producto->descripcion }}
                        </div>
                        <div class="form-group">
                            <strong>Cantidad:</strong>
                            {{ $producto->cantidad }}
                        </div>
                        <div class="form-group">
                            <strong>Costo Unidad:</strong>
                            {{ $producto->costo_unidad }}
                        </div>
                        <div class="form-group">
                            <strong>Fotos:</strong><br><br>
                            <div>
                            @foreach(explode(',', $producto->fotos) as $urlfoto)
                                <img src="/{{ $urlfoto }}" class="rounded float-start" height="220">
                            @endforeach
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection